"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.stopReceiverApp = exports.handleMediaMessage = exports.handleSessionMessage = void 0;
const castv2_1 = __importDefault(require("castv2"));
const Session_1 = __importStar(require("./Session"));
const Media_1 = __importDefault(require("./Media"));
const existingSessions = new Map();
const existingMedia = new Map();
function handleSessionMessage(message) {
    var _a;
    if (!message._id) {
        console.error("Session message missing _id");
        return;
    }
    const sessionId = message._id;
    if (existingSessions.has(sessionId)) {
        (_a = existingSessions.get(sessionId)) === null || _a === void 0 ? void 0 : _a.messageHandler(message);
    }
    else {
        if (message.subject === "bridge:/session/initialize") {
            existingSessions.set(sessionId, new Session_1.default(message.data.address, message.data.port, message.data.appId, message.data.sessionId, sessionId));
        }
    }
}
exports.handleSessionMessage = handleSessionMessage;
function handleMediaMessage(message) {
    if (!message._id) {
        console.error("Media message missing _id");
        return;
    }
    const mediaId = message._id;
    if (existingMedia.has(mediaId)) {
        existingMedia.get(mediaId).messageHandler(message);
    }
    else {
        if (message.subject === "bridge:/media/initialize") {
            const parentSession = existingSessions.get(message.data._internalSessionId);
            if (parentSession) {
                existingMedia.set(mediaId, new Media_1.default(mediaId, parentSession));
            }
        }
    }
}
exports.handleMediaMessage = handleMediaMessage;
function stopReceiverApp(host, port) {
    const client = new castv2_1.default.Client();
    client.connect({ host, port }, () => {
        const sourceId = "sender-0";
        const destinationId = "receiver-0";
        const clientConnection = client.createChannel(sourceId, destinationId, Session_1.NS_CONNECTION, "JSON");
        const clientReceiver = client.createChannel(sourceId, destinationId, Session_1.NS_RECEIVER, "JSON");
        clientConnection.send({ type: "CONNECT" });
        clientReceiver.send({ type: "STOP", requestId: 1 });
    });
}
exports.stopReceiverApp = stopReceiverApp;
