"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const minimist_1 = __importDefault(require("minimist"));
const argv = minimist_1.default(process.argv.slice(2), {
    boolean: ["daemon", "help", "version"],
    string: ["__name", "port"],
    alias: {
        d: "daemon",
        h: "help",
        v: "version",
        p: "port"
    },
    default: {
        __name: path_1.default.basename(process.argv[0]),
        daemon: false,
        port: "9556"
    }
});
if (argv.version) {
    console.log(`v0.0.7`);
}
else if (argv.help) {
    console.log(`Usage: ${argv.__name} [options]

Options:
  -h, --help       Print usage info
  -v, --version    Print version info
  -d, --daemon     Launch in daemon mode. This starts a WebSocket server that
                   the extension can be configured to connect to under bridge
                   options.
  -p, --port       Set port number for WebSocket server. This must match the
                   port set in the extension options.
`);
}
else if (argv.daemon) {
    const port = parseInt(argv.port);
    if (!port || port < 1025 || port > 65535) {
        console.error("Invalid port specified!");
        process.exit(1);
    }
    Promise.resolve().then(() => __importStar(require("./daemon"))).then(daemon => {
        daemon.init(port);
    });
}
else {
    Promise.resolve().then(() => __importStar(require("./bridge")));
}
